/* ***********************************************************
 * This file was automatically generated on 2019-08-01.      *
 *                                                           *
 * Rust Bindings Version 2.0.11                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! Measures DC voltage between 0V and 42V.
//!
//! See also the documentation [here](https://www.tinkerforge.com/en/doc/Software/Bricklets/AnalogInV3_Bricklet_Rust.html).
use crate::{
    byte_converter::*, converting_callback_receiver::ConvertingCallbackReceiver, converting_receiver::ConvertingReceiver, device::*,
    ip_connection::GetRequestSender,
};
pub enum AnalogInV3BrickletFunction {
    GetVoltage,
    SetVoltageCallbackConfiguration,
    GetVoltageCallbackConfiguration,
    SetOversampling,
    GetOversampling,
    SetCalibration,
    GetCalibration,
    GetSpitfpErrorCount,
    SetBootloaderMode,
    GetBootloaderMode,
    SetWriteFirmwarePointer,
    WriteFirmware,
    SetStatusLedConfig,
    GetStatusLedConfig,
    GetChipTemperature,
    Reset,
    WriteUid,
    ReadUid,
    GetIdentity,
    CallbackVoltage,
}
impl From<AnalogInV3BrickletFunction> for u8 {
    fn from(fun: AnalogInV3BrickletFunction) -> Self {
        match fun {
            AnalogInV3BrickletFunction::GetVoltage => 1,
            AnalogInV3BrickletFunction::SetVoltageCallbackConfiguration => 2,
            AnalogInV3BrickletFunction::GetVoltageCallbackConfiguration => 3,
            AnalogInV3BrickletFunction::SetOversampling => 5,
            AnalogInV3BrickletFunction::GetOversampling => 6,
            AnalogInV3BrickletFunction::SetCalibration => 7,
            AnalogInV3BrickletFunction::GetCalibration => 8,
            AnalogInV3BrickletFunction::GetSpitfpErrorCount => 234,
            AnalogInV3BrickletFunction::SetBootloaderMode => 235,
            AnalogInV3BrickletFunction::GetBootloaderMode => 236,
            AnalogInV3BrickletFunction::SetWriteFirmwarePointer => 237,
            AnalogInV3BrickletFunction::WriteFirmware => 238,
            AnalogInV3BrickletFunction::SetStatusLedConfig => 239,
            AnalogInV3BrickletFunction::GetStatusLedConfig => 240,
            AnalogInV3BrickletFunction::GetChipTemperature => 242,
            AnalogInV3BrickletFunction::Reset => 243,
            AnalogInV3BrickletFunction::WriteUid => 248,
            AnalogInV3BrickletFunction::ReadUid => 249,
            AnalogInV3BrickletFunction::GetIdentity => 255,
            AnalogInV3BrickletFunction::CallbackVoltage => 4,
        }
    }
}
pub const ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_OFF: char = 'x';
pub const ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_OUTSIDE: char = 'o';
pub const ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_INSIDE: char = 'i';
pub const ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_SMALLER: char = '<';
pub const ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_GREATER: char = '>';
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_32: u8 = 0;
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_64: u8 = 1;
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_128: u8 = 2;
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_256: u8 = 3;
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_512: u8 = 4;
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_1024: u8 = 5;
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_2048: u8 = 6;
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_4096: u8 = 7;
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_8192: u8 = 8;
pub const ANALOG_IN_V3_BRICKLET_OVERSAMPLING_16384: u8 = 9;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_BOOTLOADER: u8 = 0;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_FIRMWARE: u8 = 1;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT: u8 = 2;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT: u8 = 3;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT: u8 = 4;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_OK: u8 = 0;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE: u8 = 1;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE: u8 = 2;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT: u8 = 3;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT: u8 = 4;
pub const ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH: u8 = 5;
pub const ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_OFF: u8 = 0;
pub const ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_ON: u8 = 1;
pub const ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT: u8 = 2;
pub const ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS: u8 = 3;

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct VoltageCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: u16,
    pub max: u16,
}
impl FromByteSlice for VoltageCallbackConfiguration {
    fn bytes_expected() -> usize {
        10
    }
    fn from_le_byte_slice(bytes: &[u8]) -> VoltageCallbackConfiguration {
        VoltageCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
            option: <char>::from_le_byte_slice(&bytes[5..6]),
            min: <u16>::from_le_byte_slice(&bytes[6..8]),
            max: <u16>::from_le_byte_slice(&bytes[8..10]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct Calibration {
    pub offset: i16,
    pub multiplier: u16,
    pub divisor: u16,
}
impl FromByteSlice for Calibration {
    fn bytes_expected() -> usize {
        6
    }
    fn from_le_byte_slice(bytes: &[u8]) -> Calibration {
        Calibration {
            offset: <i16>::from_le_byte_slice(&bytes[0..2]),
            multiplier: <u16>::from_le_byte_slice(&bytes[2..4]),
            divisor: <u16>::from_le_byte_slice(&bytes[4..6]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SpitfpErrorCount {
    pub error_count_ack_checksum: u32,
    pub error_count_message_checksum: u32,
    pub error_count_frame: u32,
    pub error_count_overflow: u32,
}
impl FromByteSlice for SpitfpErrorCount {
    fn bytes_expected() -> usize {
        16
    }
    fn from_le_byte_slice(bytes: &[u8]) -> SpitfpErrorCount {
        SpitfpErrorCount {
            error_count_ack_checksum: <u32>::from_le_byte_slice(&bytes[0..4]),
            error_count_message_checksum: <u32>::from_le_byte_slice(&bytes[4..8]),
            error_count_frame: <u32>::from_le_byte_slice(&bytes[8..12]),
            error_count_overflow: <u32>::from_le_byte_slice(&bytes[12..16]),
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize {
        25
    }
    fn from_le_byte_slice(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_byte_slice(&bytes[0..8]),
            connected_uid: <String>::from_le_byte_slice(&bytes[8..16]),
            position: <char>::from_le_byte_slice(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_byte_slice(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_byte_slice(&bytes[20..23]),
            device_identifier: <u16>::from_le_byte_slice(&bytes[23..25]),
        }
    }
}

/// Measures DC voltage between 0V and 42V
#[derive(Clone)]
pub struct AnalogInV3Bricklet {
    device: Device,
}
impl AnalogInV3Bricklet {
    pub const DEVICE_IDENTIFIER: u16 = 295;
    pub const DEVICE_DISPLAY_NAME: &'static str = "Analog In Bricklet 3.0";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new<T: GetRequestSender>(uid: &str, req_sender: T) -> AnalogInV3Bricklet {
        let mut result = AnalogInV3Bricklet { device: Device::new([2, 0, 0], uid, req_sender, 0) };
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::GetVoltage) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::SetVoltageCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::GetVoltageCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::SetOversampling) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::GetOversampling) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::SetCalibration) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::GetCalibration) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::GetSpitfpErrorCount) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::SetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::GetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::SetWriteFirmwarePointer) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::WriteFirmware) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::SetStatusLedConfig) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::GetStatusLedConfig) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::GetChipTemperature) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::Reset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::WriteUid) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::ReadUid) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(AnalogInV3BrickletFunction::GetIdentity) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::analog_in_v3_bricklet::AnalogInV3Bricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::analog_in_v3_bricklet::AnalogInV3Bricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: AnalogInV3BrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(
        &mut self,
        fun: AnalogInV3BrickletFunction,
        response_expected: bool,
    ) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) {
        self.device.set_response_expected_all(response_expected)
    }

    /// Returns the version of the API definition (major, minor, revision) implemented by this API bindings.
    /// This is neither the release version of this API bindings nor does it tell you anything about the represented Brick or Bricklet.
    pub fn get_api_version(&self) -> [u8; 3] {
        self.device.api_version
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_voltage_callback_configuration`].
    ///
    /// The parameter is the same as [`get_voltage`].
    ///
    /// [`get_voltage`]: #method.get_voltage
    /// [`set_voltage_callback_configuration`]: #method.set_voltage_callback_configuration
    pub fn get_voltage_callback_receiver(&self) -> ConvertingCallbackReceiver<u16> {
        self.device.get_callback_receiver(u8::from(AnalogInV3BrickletFunction::CallbackVoltage))
    }

    /// Returns the measured voltage. The value is in mV and
    /// between 0V and 42V. The resolution is approximately 10mV to 1mV
    /// depending on the oversampling configuration ([`set_oversampling`]).
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_voltage_callback_receiver`] receiver. You can set the receiver configuration
    /// with [`set_voltage_callback_configuration`].
    ///
    /// [`set_voltage_callback_configuration`]: #method.set_voltage_callback_configuration
    /// [`set_oversampling`]: #method.set_oversampling
    /// [`get_voltage_callback_receiver`]: #method.get_voltage_callback_receiver
    pub fn get_voltage(&self) -> ConvertingReceiver<u16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::GetVoltage), payload)
    }

    /// The period in ms is the period with which the [`get_voltage_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_voltage_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// The default value is (0, false, 'x', 0, 0).
    ///
    /// [`get_voltage_callback_receiver`]: #method.get_voltage_callback_receiver
    ///
    /// Associated constants:
    /// * ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_voltage_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: u16,
        max: u16,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 10];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_byte_vec(option));
        payload[6..8].copy_from_slice(&<u16>::to_le_byte_vec(min));
        payload[8..10].copy_from_slice(&<u16>::to_le_byte_vec(max));

        self.device.set(u8::from(AnalogInV3BrickletFunction::SetVoltageCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by [`set_voltage_callback_configuration`].
    ///
    /// [`set_voltage_callback_configuration`]: #method.set_voltage_callback_configuration
    ///
    /// Associated constants:
    /// * ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* ANALOG_IN_V3_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_voltage_callback_configuration(&self) -> ConvertingReceiver<VoltageCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::GetVoltageCallbackConfiguration), payload)
    }

    /// Sets the oversampling between 32x and 16384x. The Bricklet
    /// takes one 12bit sample every 17.5µs. Thus an oversampling
    /// of 32x is equivalent to an integration time of 0.56ms and
    /// a oversampling of 16384x is equivalent to an integration
    /// time of 286ms.
    ///
    /// The oversampling uses the moving average principle. A
    /// new value is always calculated once per millisecond.
    ///
    /// With increased oversampling the noise decreases. With decreased
    /// oversampling the reaction time increases (changes in voltage will be
    /// measured faster).
    ///
    /// The default value is 4096x.
    ///
    /// Associated constants:
    /// * ANALOG_IN_V3_BRICKLET_OVERSAMPLING_32
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_64
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_128
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_256
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_512
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_1024
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_2048
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_4096
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_8192
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_16384
    pub fn set_oversampling(&self, oversampling: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(oversampling));

        self.device.set(u8::from(AnalogInV3BrickletFunction::SetOversampling), payload)
    }

    /// Returns the oversampling value as set by [`set_oversampling`].
    ///
    /// [`set_oversampling`]: #method.set_oversampling
    ///
    /// Associated constants:
    /// * ANALOG_IN_V3_BRICKLET_OVERSAMPLING_32
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_64
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_128
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_256
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_512
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_1024
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_2048
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_4096
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_8192
    ///	* ANALOG_IN_V3_BRICKLET_OVERSAMPLING_16384
    pub fn get_oversampling(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::GetOversampling), payload)
    }

    /// Sets a calibration for the measured voltage value.
    /// The formula for the calibration is as follows::
    ///
    ///  Calibrated Value = (Value + Offset) * Multiplier / Divisor
    ///
    /// We recommend that you use the Brick Viewer to calibrate
    /// the Bricklet. The calibration will be saved internally and only
    /// has to be done once.
    pub fn set_calibration(&self, offset: i16, multiplier: u16, divisor: u16) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 6];
        payload[0..2].copy_from_slice(&<i16>::to_le_byte_vec(offset));
        payload[2..4].copy_from_slice(&<u16>::to_le_byte_vec(multiplier));
        payload[4..6].copy_from_slice(&<u16>::to_le_byte_vec(divisor));

        self.device.set(u8::from(AnalogInV3BrickletFunction::SetCalibration), payload)
    }

    /// Returns the calibration as set by [`set_calibration`].
    ///
    /// [`set_calibration`]: #method.set_calibration
    pub fn get_calibration(&self) -> ConvertingReceiver<Calibration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::GetCalibration), payload)
    }

    /// Returns the error count for the communication between Brick and Bricklet.
    ///
    /// The errors are divided into
    ///
    /// * ACK checksum errors,
    /// * message checksum errors,
    /// * framing errors and
    /// * overflow errors.
    ///
    /// The errors counts are for errors that occur on the Bricklet side. All
    /// Bricks have a similar function that returns the errors on the Brick side.
    pub fn get_spitfp_error_count(&self) -> ConvertingReceiver<SpitfpErrorCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::GetSpitfpErrorCount), payload)
    }

    /// Sets the bootloader mode and returns the status after the requested
    /// mode change was instigated.
    ///
    /// You can change from bootloader mode to firmware mode and vice versa. A change
    /// from bootloader mode to firmware mode will only take place if the entry function,
    /// device identifier and CRC are present and correct.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// Associated constants:
    /// * ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_OK
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH
    pub fn set_bootloader_mode(&self, mode: u8) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(mode));

        self.device.get(u8::from(AnalogInV3BrickletFunction::SetBootloaderMode), payload)
    }

    /// Returns the current bootloader mode, see [`set_bootloader_mode`].
    ///
    /// [`set_bootloader_mode`]: #method.set_bootloader_mode
    ///
    /// Associated constants:
    /// * ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* ANALOG_IN_V3_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    pub fn get_bootloader_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::GetBootloaderMode), payload)
    }

    /// Sets the firmware pointer for [`write_firmware`]. The pointer has
    /// to be increased by chunks of size 64. The data is written to flash
    /// every 4 chunks (which equals to one page of size 256).
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// [`write_firmware`]: #method.write_firmware
    pub fn set_write_firmware_pointer(&self, pointer: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(pointer));

        self.device.set(u8::from(AnalogInV3BrickletFunction::SetWriteFirmwarePointer), payload)
    }

    /// Writes 64 Bytes of firmware at the position as written by
    /// [`set_write_firmware_pointer`] before. The firmware is written
    /// to flash every 4 chunks.
    ///
    /// You can only write firmware in bootloader mode.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// [`set_write_firmware_pointer`]: #method.set_write_firmware_pointer
    pub fn write_firmware(&self, data: [u8; 64]) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 64];
        payload[0..64].copy_from_slice(&<[u8; 64]>::to_le_byte_vec(data));

        self.device.get(u8::from(AnalogInV3BrickletFunction::WriteFirmware), payload)
    }

    /// Sets the status LED configuration. By default the LED shows
    /// communication traffic between Brick and Bricklet, it flickers once
    /// for every 10 received data packets.
    ///
    /// You can also turn the LED permanently on/off or show a heartbeat.
    ///
    /// If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    ///
    /// Associated constants:
    /// * ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn set_status_led_config(&self, config: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(config));

        self.device.set(u8::from(AnalogInV3BrickletFunction::SetStatusLedConfig), payload)
    }

    /// Returns the configuration as set by [`set_status_led_config`]
    ///
    /// [`set_status_led_config`]: #method.set_status_led_config
    ///
    /// Associated constants:
    /// * ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* ANALOG_IN_V3_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn get_status_led_config(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::GetStatusLedConfig), payload)
    }

    /// Returns the temperature in °C as measured inside the microcontroller. The
    /// value returned is not the ambient temperature!
    ///
    /// The temperature is only proportional to the real temperature and it has bad
    /// accuracy. Practically it is only useful as an indicator for
    /// temperature changes.
    pub fn get_chip_temperature(&self) -> ConvertingReceiver<i16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::GetChipTemperature), payload)
    }

    /// Calling this function will reset the Bricklet. All configurations
    /// will be lost.
    ///
    /// After a reset you have to create new device objects,
    /// calling functions on the existing ones will result in
    /// undefined behavior!
    pub fn reset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(AnalogInV3BrickletFunction::Reset), payload)
    }

    /// Writes a new UID into flash. If you want to set a new UID
    /// you have to decode the Base58 encoded UID string into an
    /// integer first.
    ///
    /// We recommend that you use Brick Viewer to change the UID.
    pub fn write_uid(&self, uid: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(uid));

        self.device.set(u8::from(AnalogInV3BrickletFunction::WriteUid), payload)
    }

    /// Returns the current UID as an integer. Encode as
    /// Base58 to get the usual string version.
    pub fn read_uid(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::ReadUid), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c' or 'd'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(AnalogInV3BrickletFunction::GetIdentity), payload)
    }
}
