/* ***********************************************************
 * This file was automatically generated on 2019-08-01.      *
 *                                                           *
 * Rust Bindings Version 2.0.11                              *
 *                                                           *
 * If you have a bugfix for this file and want to commit it, *
 * please fix the bug in the generator. You can find a link  *
 * to the generators git repository on tinkerforge.com       *
 *************************************************************/

//! Measures air pressure and altitude changes.
//!
//! See also the documentation [here](https://www.tinkerforge.com/en/doc/Software/Bricklets/BarometerV2_Bricklet_Rust.html).
use crate::{
    byte_converter::*, converting_callback_receiver::ConvertingCallbackReceiver, converting_receiver::ConvertingReceiver, device::*,
    ip_connection::GetRequestSender,
};
pub enum BarometerV2BrickletFunction {
    GetAirPressure,
    SetAirPressureCallbackConfiguration,
    GetAirPressureCallbackConfiguration,
    GetAltitude,
    SetAltitudeCallbackConfiguration,
    GetAltitudeCallbackConfiguration,
    GetTemperature,
    SetTemperatureCallbackConfiguration,
    GetTemperatureCallbackConfiguration,
    SetMovingAverageConfiguration,
    GetMovingAverageConfiguration,
    SetReferenceAirPressure,
    GetReferenceAirPressure,
    SetCalibration,
    GetCalibration,
    SetSensorConfiguration,
    GetSensorConfiguration,
    GetSpitfpErrorCount,
    SetBootloaderMode,
    GetBootloaderMode,
    SetWriteFirmwarePointer,
    WriteFirmware,
    SetStatusLedConfig,
    GetStatusLedConfig,
    GetChipTemperature,
    Reset,
    WriteUid,
    ReadUid,
    GetIdentity,
    CallbackAirPressure,
    CallbackAltitude,
    CallbackTemperature,
}
impl From<BarometerV2BrickletFunction> for u8 {
    fn from(fun: BarometerV2BrickletFunction) -> Self {
        match fun {
            BarometerV2BrickletFunction::GetAirPressure => 1,
            BarometerV2BrickletFunction::SetAirPressureCallbackConfiguration => 2,
            BarometerV2BrickletFunction::GetAirPressureCallbackConfiguration => 3,
            BarometerV2BrickletFunction::GetAltitude => 5,
            BarometerV2BrickletFunction::SetAltitudeCallbackConfiguration => 6,
            BarometerV2BrickletFunction::GetAltitudeCallbackConfiguration => 7,
            BarometerV2BrickletFunction::GetTemperature => 9,
            BarometerV2BrickletFunction::SetTemperatureCallbackConfiguration => 10,
            BarometerV2BrickletFunction::GetTemperatureCallbackConfiguration => 11,
            BarometerV2BrickletFunction::SetMovingAverageConfiguration => 13,
            BarometerV2BrickletFunction::GetMovingAverageConfiguration => 14,
            BarometerV2BrickletFunction::SetReferenceAirPressure => 15,
            BarometerV2BrickletFunction::GetReferenceAirPressure => 16,
            BarometerV2BrickletFunction::SetCalibration => 17,
            BarometerV2BrickletFunction::GetCalibration => 18,
            BarometerV2BrickletFunction::SetSensorConfiguration => 19,
            BarometerV2BrickletFunction::GetSensorConfiguration => 20,
            BarometerV2BrickletFunction::GetSpitfpErrorCount => 234,
            BarometerV2BrickletFunction::SetBootloaderMode => 235,
            BarometerV2BrickletFunction::GetBootloaderMode => 236,
            BarometerV2BrickletFunction::SetWriteFirmwarePointer => 237,
            BarometerV2BrickletFunction::WriteFirmware => 238,
            BarometerV2BrickletFunction::SetStatusLedConfig => 239,
            BarometerV2BrickletFunction::GetStatusLedConfig => 240,
            BarometerV2BrickletFunction::GetChipTemperature => 242,
            BarometerV2BrickletFunction::Reset => 243,
            BarometerV2BrickletFunction::WriteUid => 248,
            BarometerV2BrickletFunction::ReadUid => 249,
            BarometerV2BrickletFunction::GetIdentity => 255,
            BarometerV2BrickletFunction::CallbackAirPressure => 4,
            BarometerV2BrickletFunction::CallbackAltitude => 8,
            BarometerV2BrickletFunction::CallbackTemperature => 12,
        }
    }
}
pub const BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OFF: char = 'x';
pub const BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE: char = 'o';
pub const BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_INSIDE: char = 'i';
pub const BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_SMALLER: char = '<';
pub const BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_GREATER: char = '>';
pub const BAROMETER_V2_BRICKLET_DATA_RATE_OFF: u8 = 0;
pub const BAROMETER_V2_BRICKLET_DATA_RATE_1HZ: u8 = 1;
pub const BAROMETER_V2_BRICKLET_DATA_RATE_10HZ: u8 = 2;
pub const BAROMETER_V2_BRICKLET_DATA_RATE_25HZ: u8 = 3;
pub const BAROMETER_V2_BRICKLET_DATA_RATE_50HZ: u8 = 4;
pub const BAROMETER_V2_BRICKLET_DATA_RATE_75HZ: u8 = 5;
pub const BAROMETER_V2_BRICKLET_LOW_PASS_FILTER_OFF: u8 = 0;
pub const BAROMETER_V2_BRICKLET_LOW_PASS_FILTER_1_9TH: u8 = 1;
pub const BAROMETER_V2_BRICKLET_LOW_PASS_FILTER_1_20TH: u8 = 2;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER: u8 = 0;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE: u8 = 1;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT: u8 = 2;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT: u8 = 3;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT: u8 = 4;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_OK: u8 = 0;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE: u8 = 1;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE: u8 = 2;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT: u8 = 3;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT: u8 = 4;
pub const BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH: u8 = 5;
pub const BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_OFF: u8 = 0;
pub const BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_ON: u8 = 1;
pub const BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT: u8 = 2;
pub const BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS: u8 = 3;

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct AirPressureCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: i32,
    pub max: i32,
}
impl FromByteSlice for AirPressureCallbackConfiguration {
    fn bytes_expected() -> usize {
        14
    }
    fn from_le_byte_slice(bytes: &[u8]) -> AirPressureCallbackConfiguration {
        AirPressureCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
            option: <char>::from_le_byte_slice(&bytes[5..6]),
            min: <i32>::from_le_byte_slice(&bytes[6..10]),
            max: <i32>::from_le_byte_slice(&bytes[10..14]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct AltitudeCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: i32,
    pub max: i32,
}
impl FromByteSlice for AltitudeCallbackConfiguration {
    fn bytes_expected() -> usize {
        14
    }
    fn from_le_byte_slice(bytes: &[u8]) -> AltitudeCallbackConfiguration {
        AltitudeCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
            option: <char>::from_le_byte_slice(&bytes[5..6]),
            min: <i32>::from_le_byte_slice(&bytes[6..10]),
            max: <i32>::from_le_byte_slice(&bytes[10..14]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct TemperatureCallbackConfiguration {
    pub period: u32,
    pub value_has_to_change: bool,
    pub option: char,
    pub min: i32,
    pub max: i32,
}
impl FromByteSlice for TemperatureCallbackConfiguration {
    fn bytes_expected() -> usize {
        14
    }
    fn from_le_byte_slice(bytes: &[u8]) -> TemperatureCallbackConfiguration {
        TemperatureCallbackConfiguration {
            period: <u32>::from_le_byte_slice(&bytes[0..4]),
            value_has_to_change: <bool>::from_le_byte_slice(&bytes[4..5]),
            option: <char>::from_le_byte_slice(&bytes[5..6]),
            min: <i32>::from_le_byte_slice(&bytes[6..10]),
            max: <i32>::from_le_byte_slice(&bytes[10..14]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct MovingAverageConfiguration {
    pub moving_average_length_air_pressure: u16,
    pub moving_average_length_temperature: u16,
}
impl FromByteSlice for MovingAverageConfiguration {
    fn bytes_expected() -> usize {
        4
    }
    fn from_le_byte_slice(bytes: &[u8]) -> MovingAverageConfiguration {
        MovingAverageConfiguration {
            moving_average_length_air_pressure: <u16>::from_le_byte_slice(&bytes[0..2]),
            moving_average_length_temperature: <u16>::from_le_byte_slice(&bytes[2..4]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct Calibration {
    pub measured_air_pressure: i32,
    pub actual_air_pressure: i32,
}
impl FromByteSlice for Calibration {
    fn bytes_expected() -> usize {
        8
    }
    fn from_le_byte_slice(bytes: &[u8]) -> Calibration {
        Calibration {
            measured_air_pressure: <i32>::from_le_byte_slice(&bytes[0..4]),
            actual_air_pressure: <i32>::from_le_byte_slice(&bytes[4..8]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SensorConfiguration {
    pub data_rate: u8,
    pub air_pressure_low_pass_filter: u8,
}
impl FromByteSlice for SensorConfiguration {
    fn bytes_expected() -> usize {
        2
    }
    fn from_le_byte_slice(bytes: &[u8]) -> SensorConfiguration {
        SensorConfiguration {
            data_rate: <u8>::from_le_byte_slice(&bytes[0..1]),
            air_pressure_low_pass_filter: <u8>::from_le_byte_slice(&bytes[1..2]),
        }
    }
}

#[derive(Clone, Copy, Debug, Default, PartialEq, Eq, Hash)]
pub struct SpitfpErrorCount {
    pub error_count_ack_checksum: u32,
    pub error_count_message_checksum: u32,
    pub error_count_frame: u32,
    pub error_count_overflow: u32,
}
impl FromByteSlice for SpitfpErrorCount {
    fn bytes_expected() -> usize {
        16
    }
    fn from_le_byte_slice(bytes: &[u8]) -> SpitfpErrorCount {
        SpitfpErrorCount {
            error_count_ack_checksum: <u32>::from_le_byte_slice(&bytes[0..4]),
            error_count_message_checksum: <u32>::from_le_byte_slice(&bytes[4..8]),
            error_count_frame: <u32>::from_le_byte_slice(&bytes[8..12]),
            error_count_overflow: <u32>::from_le_byte_slice(&bytes[12..16]),
        }
    }
}

#[derive(Clone, Debug, Default, PartialEq, Eq, Hash)]
pub struct Identity {
    pub uid: String,
    pub connected_uid: String,
    pub position: char,
    pub hardware_version: [u8; 3],
    pub firmware_version: [u8; 3],
    pub device_identifier: u16,
}
impl FromByteSlice for Identity {
    fn bytes_expected() -> usize {
        25
    }
    fn from_le_byte_slice(bytes: &[u8]) -> Identity {
        Identity {
            uid: <String>::from_le_byte_slice(&bytes[0..8]),
            connected_uid: <String>::from_le_byte_slice(&bytes[8..16]),
            position: <char>::from_le_byte_slice(&bytes[16..17]),
            hardware_version: <[u8; 3]>::from_le_byte_slice(&bytes[17..20]),
            firmware_version: <[u8; 3]>::from_le_byte_slice(&bytes[20..23]),
            device_identifier: <u16>::from_le_byte_slice(&bytes[23..25]),
        }
    }
}

/// Measures air pressure and altitude changes
#[derive(Clone)]
pub struct BarometerV2Bricklet {
    device: Device,
}
impl BarometerV2Bricklet {
    pub const DEVICE_IDENTIFIER: u16 = 2117;
    pub const DEVICE_DISPLAY_NAME: &'static str = "Barometer Bricklet 2.0";
    /// Creates an object with the unique device ID `uid`. This object can then be used after the IP Connection `ip_connection` is connected.
    pub fn new<T: GetRequestSender>(uid: &str, req_sender: T) -> BarometerV2Bricklet {
        let mut result = BarometerV2Bricklet { device: Device::new([2, 0, 0], uid, req_sender, 0) };
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetAirPressure) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetAirPressureCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetAirPressureCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetAltitude) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetAltitudeCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetAltitudeCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetTemperature) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetTemperatureCallbackConfiguration) as usize] =
            ResponseExpectedFlag::True;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetTemperatureCallbackConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetMovingAverageConfiguration) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetMovingAverageConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetReferenceAirPressure) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetReferenceAirPressure) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetCalibration) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetCalibration) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetSensorConfiguration) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetSensorConfiguration) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetSpitfpErrorCount) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetBootloaderMode) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetWriteFirmwarePointer) as usize] =
            ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::WriteFirmware) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::SetStatusLedConfig) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetStatusLedConfig) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetChipTemperature) as usize] =
            ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::Reset) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::WriteUid) as usize] = ResponseExpectedFlag::False;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::ReadUid) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result.device.response_expected[u8::from(BarometerV2BrickletFunction::GetIdentity) as usize] = ResponseExpectedFlag::AlwaysTrue;
        result
    }

    /// Returns the response expected flag for the function specified by the function ID parameter.
    /// It is true if the function is expected to send a response, false otherwise.
    ///
    /// For getter functions this is enabled by default and cannot be disabled, because those
    /// functions will always send a response. For callback configuration functions it is enabled
    /// by default too, but can be disabled by [`set_response_expected`](crate::barometer_v2_bricklet::BarometerV2Bricklet::set_response_expected).
    /// For setter functions it is disabled by default and can be enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts
    /// and other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    ///
    /// See [`set_response_expected`](crate::barometer_v2_bricklet::BarometerV2Bricklet::set_response_expected) for the list of function ID constants available for this function.
    pub fn get_response_expected(&mut self, fun: BarometerV2BrickletFunction) -> Result<bool, GetResponseExpectedError> {
        self.device.get_response_expected(u8::from(fun))
    }

    /// Changes the response expected flag of the function specified by the function ID parameter.
    /// This flag can only be changed for setter (default value: false) and callback configuration
    /// functions (default value: true). For getter functions it is always enabled.
    ///
    /// Enabling the response expected flag for a setter function allows to detect timeouts and
    /// other error conditions calls of this setter as well. The device will then send a response
    /// for this purpose. If this flag is disabled for a setter function then no response is send
    /// and errors are silently ignored, because they cannot be detected.
    pub fn set_response_expected(
        &mut self,
        fun: BarometerV2BrickletFunction,
        response_expected: bool,
    ) -> Result<(), SetResponseExpectedError> {
        self.device.set_response_expected(u8::from(fun), response_expected)
    }

    /// Changes the response expected flag for all setter and callback configuration functions of this device at once.
    pub fn set_response_expected_all(&mut self, response_expected: bool) {
        self.device.set_response_expected_all(response_expected)
    }

    /// Returns the version of the API definition (major, minor, revision) implemented by this API bindings.
    /// This is neither the release version of this API bindings nor does it tell you anything about the represented Brick or Bricklet.
    pub fn get_api_version(&self) -> [u8; 3] {
        self.device.api_version
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_air_pressure_callback_configuration`].
    ///
    /// The parameter is the same as [`get_air_pressure`].
    ///
    /// [`get_air_pressure`]: #method.get_air_pressure
    /// [`set_air_pressure_callback_configuration`]: #method.set_air_pressure_callback_configuration
    pub fn get_air_pressure_callback_receiver(&self) -> ConvertingCallbackReceiver<i32> {
        self.device.get_callback_receiver(u8::from(BarometerV2BrickletFunction::CallbackAirPressure))
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_altitude_callback_configuration`].
    ///
    /// The parameter is the same as [`get_altitude`].
    ///
    /// [`get_altitude`]: #method.get_altitude
    /// [`set_altitude_callback_configuration`]: #method.set_altitude_callback_configuration
    pub fn get_altitude_callback_receiver(&self) -> ConvertingCallbackReceiver<i32> {
        self.device.get_callback_receiver(u8::from(BarometerV2BrickletFunction::CallbackAltitude))
    }

    /// This receiver is triggered periodically according to the configuration set by
    /// [`set_temperature_callback_configuration`].
    ///
    /// The parameter is the same as [`get_temperature`].
    ///
    /// [`get_temperature`]: #method.get_temperature
    /// [`set_temperature_callback_configuration`]: #method.set_temperature_callback_configuration
    pub fn get_temperature_callback_receiver(&self) -> ConvertingCallbackReceiver<i32> {
        self.device.get_callback_receiver(u8::from(BarometerV2BrickletFunction::CallbackTemperature))
    }

    /// Returns the measured air pressure. The value has a range of
    /// 260000 to 1260000 and is given in mbar/1000, i.e. a value of
    /// 1001092 means that an air pressure of 1001.092 mbar is measured.
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_air_pressure_callback_receiver`] receiver. You can set the receiver configuration
    /// with [`set_air_pressure_callback_configuration`].
    ///
    /// [`set_air_pressure_callback_configuration`]: #method.set_air_pressure_callback_configuration
    /// [`get_air_pressure_callback_receiver`]: #method.get_air_pressure_callback_receiver
    pub fn get_air_pressure(&self) -> ConvertingReceiver<i32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetAirPressure), payload)
    }

    /// The period in ms is the period with which the [`get_air_pressure_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_air_pressure_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// The default value is (0, false, 'x', 0, 0).
    ///
    /// [`get_air_pressure_callback_receiver`]: #method.get_air_pressure_callback_receiver
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_air_pressure_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: i32,
        max: i32,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 14];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_byte_vec(option));
        payload[6..10].copy_from_slice(&<i32>::to_le_byte_vec(min));
        payload[10..14].copy_from_slice(&<i32>::to_le_byte_vec(max));

        self.device.set(u8::from(BarometerV2BrickletFunction::SetAirPressureCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by [`set_air_pressure_callback_configuration`].
    ///
    /// [`set_air_pressure_callback_configuration`]: #method.set_air_pressure_callback_configuration
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_air_pressure_callback_configuration(&self) -> ConvertingReceiver<AirPressureCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetAirPressureCallbackConfiguration), payload)
    }

    /// Returns the relative altitude of the air pressure sensor. The value
    /// is given in mm and is calculated based on the difference between the
    /// current air pressure and the reference air pressure that can be set
    /// with [`set_reference_air_pressure`].
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_altitude_callback_receiver`] receiver. You can set the receiver configuration
    /// with [`set_altitude_callback_configuration`].
    ///
    /// [`set_altitude_callback_configuration`]: #method.set_altitude_callback_configuration
    /// [`set_reference_air_pressure`]: #method.set_reference_air_pressure
    /// [`get_altitude_callback_receiver`]: #method.get_altitude_callback_receiver
    pub fn get_altitude(&self) -> ConvertingReceiver<i32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetAltitude), payload)
    }

    /// The period in ms is the period with which the [`get_altitude_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_altitude_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// The default value is (0, false, 'x', 0, 0).
    ///
    /// [`get_altitude_callback_receiver`]: #method.get_altitude_callback_receiver
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_altitude_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: i32,
        max: i32,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 14];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_byte_vec(option));
        payload[6..10].copy_from_slice(&<i32>::to_le_byte_vec(min));
        payload[10..14].copy_from_slice(&<i32>::to_le_byte_vec(max));

        self.device.set(u8::from(BarometerV2BrickletFunction::SetAltitudeCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by [`set_altitude_callback_configuration`].
    ///
    /// [`set_altitude_callback_configuration`]: #method.set_altitude_callback_configuration
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_altitude_callback_configuration(&self) -> ConvertingReceiver<AltitudeCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetAltitudeCallbackConfiguration), payload)
    }

    /// Returns the temperature of the air pressure sensor. The value
    /// has a range of -4000 to 8500 and is given in °C/100, i.e. a value
    /// of 2007 means that a temperature of 20.07 °C is measured.
    ///
    /// This temperature is used internally for temperature compensation
    /// of the air pressure measurement. It is not as accurate as the
    /// temperature measured by the `temperature_v2_bricklet` or the
    /// `temperature_ir_v2_bricklet`.
    ///
    ///
    /// If you want to get the value periodically, it is recommended to use the
    /// [`get_temperature_callback_receiver`] receiver. You can set the receiver configuration
    /// with [`set_temperature_callback_configuration`].
    ///
    /// [`set_temperature_callback_configuration`]: #method.set_temperature_callback_configuration
    /// [`get_temperature_callback_receiver`]: #method.get_temperature_callback_receiver
    pub fn get_temperature(&self) -> ConvertingReceiver<i32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetTemperature), payload)
    }

    /// The period in ms is the period with which the [`get_temperature_callback_receiver`] receiver is triggered
    /// periodically. A value of 0 turns the receiver off.
    ///
    /// If the `value has to change`-parameter is set to true, the receiver is only
    /// triggered after the value has changed. If the value didn't change
    /// within the period, the receiver is triggered immediately on change.
    ///
    /// If it is set to false, the receiver is continuously triggered with the period,
    /// independent of the value.
    ///
    /// It is furthermore possible to constrain the receiver with thresholds.
    ///
    /// The `option`-parameter together with min/max sets a threshold for the [`get_temperature_callback_receiver`] receiver.
    ///
    /// The following options are possible:
    ///
    ///  Option| Description
    ///  --- | ---
    ///  'x'|    Threshold is turned off
    ///  'o'|    Threshold is triggered when the value is *outside* the min and max values
    ///  'i'|    Threshold is triggered when the value is *inside* or equal to the min and max values
    ///  '<'|    Threshold is triggered when the value is smaller than the min value (max is ignored)
    ///  '>'|    Threshold is triggered when the value is greater than the min value (max is ignored)
    ///
    /// If the option is set to 'x' (threshold turned off) the receiver is triggered with the fixed period.
    ///
    /// The default value is (0, false, 'x', 0, 0).
    ///
    /// [`get_temperature_callback_receiver`]: #method.get_temperature_callback_receiver
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn set_temperature_callback_configuration(
        &self,
        period: u32,
        value_has_to_change: bool,
        option: char,
        min: i32,
        max: i32,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 14];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(period));
        payload[4..5].copy_from_slice(&<bool>::to_le_byte_vec(value_has_to_change));
        payload[5..6].copy_from_slice(&<char>::to_le_byte_vec(option));
        payload[6..10].copy_from_slice(&<i32>::to_le_byte_vec(min));
        payload[10..14].copy_from_slice(&<i32>::to_le_byte_vec(max));

        self.device.set(u8::from(BarometerV2BrickletFunction::SetTemperatureCallbackConfiguration), payload)
    }

    /// Returns the receiver configuration as set by [`set_temperature_callback_configuration`].
    ///
    /// [`set_temperature_callback_configuration`]: #method.set_temperature_callback_configuration
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OFF
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_OUTSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_INSIDE
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_SMALLER
    ///	* BAROMETER_V2_BRICKLET_THRESHOLD_OPTION_GREATER
    pub fn get_temperature_callback_configuration(&self) -> ConvertingReceiver<TemperatureCallbackConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetTemperatureCallbackConfiguration), payload)
    }

    /// Sets the length of a [moving averaging](https://en.wikipedia.org/wiki/Moving_average)__
    /// for the air pressure and temperature measurements.
    ///
    /// Setting the length to 1 will turn the averaging off. With less
    /// averaging, there is more noise on the data.
    ///
    /// The range for the averaging is 1-1000.
    ///
    /// If you want to do long term measurements the longest moving average will give
    /// the cleanest results.
    ///
    /// The default value is 100.
    pub fn set_moving_average_configuration(
        &self,
        moving_average_length_air_pressure: u16,
        moving_average_length_temperature: u16,
    ) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..2].copy_from_slice(&<u16>::to_le_byte_vec(moving_average_length_air_pressure));
        payload[2..4].copy_from_slice(&<u16>::to_le_byte_vec(moving_average_length_temperature));

        self.device.set(u8::from(BarometerV2BrickletFunction::SetMovingAverageConfiguration), payload)
    }

    /// Returns the moving average configuration as set by
    /// [`set_moving_average_configuration`].
    ///
    /// [`set_moving_average_configuration`]: #method.set_moving_average_configuration
    pub fn get_moving_average_configuration(&self) -> ConvertingReceiver<MovingAverageConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetMovingAverageConfiguration), payload)
    }

    /// Sets the reference air pressure in mbar/1000 for the altitude calculation.
    /// Valid values are between 260000 and 1260000. Setting the reference to the
    /// current air pressure results in a calculated altitude of 0mm. Passing 0 is
    /// a shortcut for passing the current air pressure as reference.
    ///
    /// Well known reference values are the Q codes
    /// [QNH](https://en.wikipedia.org/wiki/QNH)__ and
    /// [QFE](https://en.wikipedia.org/wiki/Mean_sea_level_pressure#Mean_sea_level_pressure)__
    /// used in aviation.
    ///
    /// The default value is 1013.25mbar.
    pub fn set_reference_air_pressure(&self, air_pressure: i32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<i32>::to_le_byte_vec(air_pressure));

        self.device.set(u8::from(BarometerV2BrickletFunction::SetReferenceAirPressure), payload)
    }

    /// Returns the reference air pressure as set by [`set_reference_air_pressure`].
    ///
    /// [`set_reference_air_pressure`]: #method.set_reference_air_pressure
    pub fn get_reference_air_pressure(&self) -> ConvertingReceiver<i32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetReferenceAirPressure), payload)
    }

    /// Sets the one point calibration (OPC) values for the air pressure measurement.
    ///
    /// Before the Bricklet can be calibrated any previous calibration has to be removed
    /// by setting ``measured air pressure`` and ``actual air pressure`` to 0.
    ///
    /// Then the current air pressure has to be measured using the Bricklet
    /// (``measured air pressure``) and with and accurate reference barometer
    /// (``actual air pressure``) at the same time and passed to this function in
    /// mbar/1000.
    ///
    /// After proper calibration the air pressure measurement can achieve an accuracy
    /// up to 0.2 mbar.
    ///
    /// The calibration is saved in the EEPROM of the Bricklet and only needs to be
    /// configured once.
    pub fn set_calibration(&self, measured_air_pressure: i32, actual_air_pressure: i32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 8];
        payload[0..4].copy_from_slice(&<i32>::to_le_byte_vec(measured_air_pressure));
        payload[4..8].copy_from_slice(&<i32>::to_le_byte_vec(actual_air_pressure));

        self.device.set(u8::from(BarometerV2BrickletFunction::SetCalibration), payload)
    }

    /// Returns the air pressure one point calibration values as set by
    /// [`set_calibration`].
    ///
    /// [`set_calibration`]: #method.set_calibration
    pub fn get_calibration(&self) -> ConvertingReceiver<Calibration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetCalibration), payload)
    }

    /// Configures the data rate and air pressure low pass filter. The low pass filter
    /// cut-off frequency (if enabled) can be set to 1/9th or 1/20th of the configure
    /// data rate to decrease the noise on the air pressure data.
    ///
    /// The low pass filter configuration only applies to the air pressure measurement.
    /// There is no low pass filter for the temperature measurement.
    ///
    /// A higher data rate will result in a less precise temperature because of
    /// self-heating of the sensor. If the accuracy of the temperature reading is
    /// important to you, we would recommend the 1Hz data rate.
    ///
    /// The default values are 50Hz data rate and 1/9th low pass filter.
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_DATA_RATE_OFF
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_1HZ
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_10HZ
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_25HZ
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_50HZ
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_75HZ
    ///	* BAROMETER_V2_BRICKLET_LOW_PASS_FILTER_OFF
    ///	* BAROMETER_V2_BRICKLET_LOW_PASS_FILTER_1_9TH
    ///	* BAROMETER_V2_BRICKLET_LOW_PASS_FILTER_1_20TH
    pub fn set_sensor_configuration(&self, data_rate: u8, air_pressure_low_pass_filter: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 2];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(data_rate));
        payload[1..2].copy_from_slice(&<u8>::to_le_byte_vec(air_pressure_low_pass_filter));

        self.device.set(u8::from(BarometerV2BrickletFunction::SetSensorConfiguration), payload)
    }

    /// Returns the sensor configuration as set by [`set_sensor_configuration`].
    ///
    /// [`set_sensor_configuration`]: #method.set_sensor_configuration
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_DATA_RATE_OFF
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_1HZ
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_10HZ
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_25HZ
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_50HZ
    ///	* BAROMETER_V2_BRICKLET_DATA_RATE_75HZ
    ///	* BAROMETER_V2_BRICKLET_LOW_PASS_FILTER_OFF
    ///	* BAROMETER_V2_BRICKLET_LOW_PASS_FILTER_1_9TH
    ///	* BAROMETER_V2_BRICKLET_LOW_PASS_FILTER_1_20TH
    pub fn get_sensor_configuration(&self) -> ConvertingReceiver<SensorConfiguration> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetSensorConfiguration), payload)
    }

    /// Returns the error count for the communication between Brick and Bricklet.
    ///
    /// The errors are divided into
    ///
    /// * ACK checksum errors,
    /// * message checksum errors,
    /// * framing errors and
    /// * overflow errors.
    ///
    /// The errors counts are for errors that occur on the Bricklet side. All
    /// Bricks have a similar function that returns the errors on the Brick side.
    pub fn get_spitfp_error_count(&self) -> ConvertingReceiver<SpitfpErrorCount> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetSpitfpErrorCount), payload)
    }

    /// Sets the bootloader mode and returns the status after the requested
    /// mode change was instigated.
    ///
    /// You can change from bootloader mode to firmware mode and vice versa. A change
    /// from bootloader mode to firmware mode will only take place if the entry function,
    /// device identifier and CRC are present and correct.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_OK
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_INVALID_MODE
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_NO_CHANGE
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_ENTRY_FUNCTION_NOT_PRESENT
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_DEVICE_IDENTIFIER_INCORRECT
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_STATUS_CRC_MISMATCH
    pub fn set_bootloader_mode(&self, mode: u8) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(mode));

        self.device.get(u8::from(BarometerV2BrickletFunction::SetBootloaderMode), payload)
    }

    /// Returns the current bootloader mode, see [`set_bootloader_mode`].
    ///
    /// [`set_bootloader_mode`]: #method.set_bootloader_mode
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_BOOTLOADER_WAIT_FOR_REBOOT
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_REBOOT
    ///	* BAROMETER_V2_BRICKLET_BOOTLOADER_MODE_FIRMWARE_WAIT_FOR_ERASE_AND_REBOOT
    pub fn get_bootloader_mode(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetBootloaderMode), payload)
    }

    /// Sets the firmware pointer for [`write_firmware`]. The pointer has
    /// to be increased by chunks of size 64. The data is written to flash
    /// every 4 chunks (which equals to one page of size 256).
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// [`write_firmware`]: #method.write_firmware
    pub fn set_write_firmware_pointer(&self, pointer: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(pointer));

        self.device.set(u8::from(BarometerV2BrickletFunction::SetWriteFirmwarePointer), payload)
    }

    /// Writes 64 Bytes of firmware at the position as written by
    /// [`set_write_firmware_pointer`] before. The firmware is written
    /// to flash every 4 chunks.
    ///
    /// You can only write firmware in bootloader mode.
    ///
    /// This function is used by Brick Viewer during flashing. It should not be
    /// necessary to call it in a normal user program.
    ///
    /// [`set_write_firmware_pointer`]: #method.set_write_firmware_pointer
    pub fn write_firmware(&self, data: [u8; 64]) -> ConvertingReceiver<u8> {
        let mut payload = vec![0; 64];
        payload[0..64].copy_from_slice(&<[u8; 64]>::to_le_byte_vec(data));

        self.device.get(u8::from(BarometerV2BrickletFunction::WriteFirmware), payload)
    }

    /// Sets the status LED configuration. By default the LED shows
    /// communication traffic between Brick and Bricklet, it flickers once
    /// for every 10 received data packets.
    ///
    /// You can also turn the LED permanently on/off or show a heartbeat.
    ///
    /// If the Bricklet is in bootloader mode, the LED is will show heartbeat by default.
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn set_status_led_config(&self, config: u8) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 1];
        payload[0..1].copy_from_slice(&<u8>::to_le_byte_vec(config));

        self.device.set(u8::from(BarometerV2BrickletFunction::SetStatusLedConfig), payload)
    }

    /// Returns the configuration as set by [`set_status_led_config`]
    ///
    /// [`set_status_led_config`]: #method.set_status_led_config
    ///
    /// Associated constants:
    /// * BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_OFF
    ///	* BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_ON
    ///	* BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_HEARTBEAT
    ///	* BAROMETER_V2_BRICKLET_STATUS_LED_CONFIG_SHOW_STATUS
    pub fn get_status_led_config(&self) -> ConvertingReceiver<u8> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetStatusLedConfig), payload)
    }

    /// Returns the temperature in °C as measured inside the microcontroller. The
    /// value returned is not the ambient temperature!
    ///
    /// The temperature is only proportional to the real temperature and it has bad
    /// accuracy. Practically it is only useful as an indicator for
    /// temperature changes.
    pub fn get_chip_temperature(&self) -> ConvertingReceiver<i16> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetChipTemperature), payload)
    }

    /// Calling this function will reset the Bricklet. All configurations
    /// will be lost.
    ///
    /// After a reset you have to create new device objects,
    /// calling functions on the existing ones will result in
    /// undefined behavior!
    pub fn reset(&self) -> ConvertingReceiver<()> {
        let payload = vec![0; 0];

        self.device.set(u8::from(BarometerV2BrickletFunction::Reset), payload)
    }

    /// Writes a new UID into flash. If you want to set a new UID
    /// you have to decode the Base58 encoded UID string into an
    /// integer first.
    ///
    /// We recommend that you use Brick Viewer to change the UID.
    pub fn write_uid(&self, uid: u32) -> ConvertingReceiver<()> {
        let mut payload = vec![0; 4];
        payload[0..4].copy_from_slice(&<u32>::to_le_byte_vec(uid));

        self.device.set(u8::from(BarometerV2BrickletFunction::WriteUid), payload)
    }

    /// Returns the current UID as an integer. Encode as
    /// Base58 to get the usual string version.
    pub fn read_uid(&self) -> ConvertingReceiver<u32> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::ReadUid), payload)
    }

    /// Returns the UID, the UID where the Bricklet is connected to,
    /// the position, the hardware and firmware version as well as the
    /// device identifier.
    ///
    /// The position can be 'a', 'b', 'c' or 'd'.
    ///
    /// The device identifier numbers can be found [here](device_identifier).
    /// |device_identifier_constant|
    pub fn get_identity(&self) -> ConvertingReceiver<Identity> {
        let payload = vec![0; 0];

        self.device.get(u8::from(BarometerV2BrickletFunction::GetIdentity), payload)
    }
}
